--TerrainMap uses the "Compass Tiles" resources to build a world map

-- this is a beta build and has extremely limited functionality

local importPath=string.gsub(getfenv(1)._.Name,"%.Main","").."."
local resourcePath=string.gsub(importPath,"%.","/").."Resources/"
tilePath=string.gsub(importPath,"%.","/").."Tiles/"

import "Turbine.UI";
import "Turbine.UI.Lotro";
import (importPath.."Class");
import (importPath.."Table");
import (importPath.."VindarPatch");
import (importPath.."DebugWindow");
import (importPath.."Grid");

function SaveData()
end

function LoadData()
end

mapWindow = Turbine.UI.Window();
mapWindow:SetWantsKeyEvents(true);
mapWindow.ZoomLevel=1

local displayWidth, displayHeight = Turbine.UI.Display.GetSize();
mapWindow:SetSize(displayWidth,displayHeight);
mapWindow:SetPosition( 0, 0);
mapWindow:SetBackColor(Turbine.UI.Color(0,0,0));
mapWindow:SetOpacity(1);

mapWindow.Region=RadioButtonGroup()
mapWindow.Region:SetParent(mapWindow)
mapWindow.Region:SetSize(280,20)
mapWindow.Region.UnselectedIcon=resourcePath.."RB_unselected.tga";
mapWindow.Region.SelectedIcon=resourcePath.."RB_selected.tga";
mapWindow.Region.IconWidth=16;
mapWindow.Region.IconHeight=16;
mapWindow.Region:AddChoice("Eriador");
mapWindow.Region:AddChoice("Rhovanion");
mapWindow.Region:SetRows(1);
mapWindow.Region:SetSelectedChoice(1);
mapWindow.Region.SelectionChanged=function()
	local region=mapWindow.Region:GetSelectedChoice()
	local maxRows=(MaxRow[region]-mapWindow.GridRows+2)*200-1
	local maxCols=(MaxCol[region]-mapWindow.GridCols+2)*200-1
	if mapWindow.vGridScroll:GetValue()>maxRows then
		mapWindow.vGridScroll:SetValue(maxRows)
	end
	if mapWindow.hGridScroll:GetValue()>maxCols then
		mapWindow.hGridScroll:SetValue(maxCols)
	end
	mapWindow.vGridScroll:SetMaximum(maxRows)
	mapWindow.hGridScroll:SetMaximum(maxCols)
	mapWindow.ReloadGrid()
end

mapWindow.YCap=Turbine.UI.Label()
mapWindow.YCap:SetParent(mapWindow)
mapWindow.YCap:SetBackColor(Turbine.UI.Color.Black)
mapWindow.YCap:SetSize(30,20)
mapWindow.YCap:SetPosition(280,0)
mapWindow.YCap:SetText("NS:")
mapWindow.YCap:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight);

mapWindow.Y=Turbine.UI.TextBox()
mapWindow.Y:SetParent(mapWindow)
mapWindow.Y:SetBackColor(Turbine.UI.Color.Black)
mapWindow.Y:SetSize(70,20)
mapWindow.Y:SetPosition(310,0)
mapWindow.Y:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
mapWindow.Y:SetText("")

mapWindow.XCap=Turbine.UI.Label()
mapWindow.XCap:SetParent(mapWindow)
mapWindow.XCap:SetBackColor(Turbine.UI.Color.Black)
mapWindow.XCap:SetSize(30,20)
mapWindow.XCap:SetPosition(380,0)
mapWindow.XCap:SetText("EW:")
mapWindow.XCap:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight);

mapWindow.X=Turbine.UI.TextBox()
mapWindow.X:SetParent(mapWindow)
mapWindow.X:SetBackColor(Turbine.UI.Color.Black)
mapWindow.X:SetSize(70,20)
mapWindow.X:SetPosition(410,0)
mapWindow.X:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
mapWindow.X:SetText("")

mapWindow.Zoom=RadioButtonGroup()
mapWindow.Zoom:SetParent(mapWindow)
mapWindow.Zoom:SetSize(200,20)
mapWindow.Zoom:SetPosition(600,0)
mapWindow.Zoom.UnselectedIcon=resourcePath.."RB_unselected.tga";
mapWindow.Zoom.SelectedIcon=resourcePath.."RB_selected.tga";
mapWindow.Zoom.IconWidth=16;
mapWindow.Zoom.IconHeight=16;
mapWindow.Zoom:AddChoice("X1");
mapWindow.Zoom:AddChoice("X2");
--mapWindow.Zoom:AddChoice("X4");
--mapWindow.Zoom:AddChoice("X8");
mapWindow.Zoom:SetRows(1);
mapWindow.Zoom:SetSelectedChoice(1);
mapWindow.Zoom.SelectionChanged=function()
	mapWindow.ZoomLevel=mapWindow.Zoom:GetSelectedChoice()
	mapWindow.MakeGrid()
	mapWindow.ReloadGrid()
end

mapWindow.Usage=Turbine.UI.Control()
mapWindow.Usage:SetParent(mapWindow)
mapWindow.Usage:SetSize(26,20)
mapWindow.Usage:SetPosition(826,0)
mapWindow.Usage:SetBackground(resourcePath.."UsageButton.jpg")
mapWindow.Usage.MouseClick=function()
	usageWindow.UpdateUsage()
	usageWindow:SetVisible(true)
end

-- we need to create a grid of 200x200 controls that get backgrounds assigned from the list of tiles

mapWindow.mapGrid=Turbine.UI.Control();
mapWindow.mapGrid:SetParent(mapWindow);
mapWindow.mapGrid:SetSize(mapWindow:GetWidth()-10,mapWindow:GetHeight()-20);
mapWindow.mapGrid:SetPosition(0,20);
mapWindow.mapGrid:SetBackColor(Turbine.UI.Color(0,0,0));

mapWindow.GridRows=math.floor(mapWindow.mapGrid:GetHeight()/200)+2
mapWindow.GridCols=math.floor(mapWindow.mapGrid:GetWidth()/200)+2

LoadData();

mapWindow.GridCells={};
mapWindow.GridSelectedResource=""
mapWindow.MakeGrid=function()
	-- remove prior grid, especially event handlers,if any
	for row,rowData in ipairs(mapWindow.GridCells) do
		for col,colData in ipairs(rowData) do
			mapWindow.GridCells[row][col].MouseEnter=nil
			mapWindow.GridCells[row][col].MouseLeave=nil
			mapWindow.GridCells[row][col].MouseUp=nil
			mapWindow.GridCells[row][col].MouseDown=nil
			mapWindow.GridCells[row][col].MouseClick=nil
			mapWindow.GridCells[row][col].MouseMove=nil
			mapWindow.GridCells[row][col].ResourceID=nil
			mapWindow.GridCells[row][col].SelectedOverlay=nil
			mapWindow.GridCells[row][col]=nil
		end
		mapWindow.GridCells[row]=nil		
	end
	-- create new grid
	mapWindow.mapGrid:SetStretchMode(0)
	local zoomMult=1
	if mapWindow.ZoomLevel/2==math.floor(mapWindow.ZoomLevel/2) then zoomMult=2 end

	mapWindow.mapGrid:SetSize((mapWindow:GetWidth()-10)*zoomMult,(mapWindow:GetHeight()-30)*zoomMult);

	for row=1,mapWindow.GridRows*zoomMult do
		mapWindow.GridCells[row]={}
		for col=1,mapWindow.GridCols*zoomMult do
			mapWindow.GridCells[row][col]=Turbine.UI.Label()
			mapWindow.GridCells[row][col]:SetParent(mapWindow.mapGrid)
			mapWindow.GridCells[row][col]:SetSize(200,200)
			mapWindow.GridCells[row][col]:SetPosition((col-1)*200,(row-1)*200)
			mapWindow.GridCells[row][col].Row=row
			mapWindow.GridCells[row][col].Col=col

			mapWindow.GridCells[row][col].MouseMove=function(sender,args)

--*** to do
-- display the NS and EW coordinates
			end
		end
	end
	if zoomMult==2 then
		mapWindow.mapGrid:SetStretchMode(1)
	end
	mapWindow.mapGrid:SetSize(mapWindow:GetWidth()-10,mapWindow:GetHeight()-30);
end
mapWindow.MakeGrid()
mapWindow.ReloadGrid=function()
	local region=mapWindow.Region:GetSelectedChoice()
	local x=math.floor(mapWindow.hGridScroll:GetValue()/200)
	local y=math.floor(mapWindow.vGridScroll:GetValue()/200)
	local zoom=1
	if x==nil then x=0 end
	if y==nil then y=0 end
	if mapWindow.ZoomLevel>2 then
		zoom=4
		x=math.floor(x/zoom)*zoom
		y=math.floor(y/zoom)*zoom
	end
	for row,rowCells in ipairs(mapWindow.GridCells) do
		for col,Cell in ipairs(rowCells) do
			local tmpRegion=Grid[region]
			local tmpCell
			local row2=(row-1)*zoom+y+1
			local col2=(col-1)*zoom+x+1

			if tmpRegion~=nil then
				local tmpRow=tmpRegion[row2]
				if tmpRow~=nil then
					local tmpCol=tmpRow[col2]
					if tmpCol~=nil then
						tmpCell=tmpCol[zoom]
					end
				end
			end
			if tmpCell==nil then
				Cell:SetBackColor(Turbine.UI.Color(.2,.2,.2))
				Cell.ResourceID=nil
			else
				Cell.ResourceID=tmpCell
				Cell:SetBackColor(nil)
			end
			if type(tmpCell)=="string" then
				success,result=pcall(Turbine.UI.Control.SetBackground,Cell,tilePath..tmpCell)
			else
				Cell:SetBackground(tmpCell)
			end
		end
	end
end

-- main control needs scroll bars
mapWindow.vGridScroll=Turbine.UI.Lotro.ScrollBar();
mapWindow.vGridScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
mapWindow.vGridScroll:SetParent(mapWindow);
mapWindow.vGridScroll:SetBackColor(Turbine.UI.Color(0,0,0));
mapWindow.vGridScroll:SetWidth(10);
mapWindow.vGridScroll:SetHeight(mapWindow.mapGrid:GetHeight());
mapWindow.vGridScroll:SetPosition(mapWindow.mapGrid:GetLeft()+mapWindow.mapGrid:GetWidth(),mapWindow.mapGrid:GetTop());
mapWindow.vGridScroll:SetZOrder(mapWindow.mapGrid:GetZOrder()+1);
mapWindow.vGridScroll:SetMinimum(0)
-- -mapWindow.GridRows+1
mapWindow.vGridScroll:SetMaximum((MaxRow[1]-mapWindow.GridRows+2)*200-1)

mapWindow.vGridScroll:SetValue(0)
mapWindow.vGridScroll:SetVisible(true);
mapWindow.vGridScroll.ValueChanged=function(sender,args)
	local yValue=mapWindow.vGridScroll:GetValue();
	local y=math.floor(yValue/200)
	local yOffset=yValue-y*200

	-- now move all of the grid elements to the yOffset
	for row,rowCells in ipairs(mapWindow.GridCells) do
		for col,Cell in ipairs(rowCells) do
			Cell:SetTop((row-1)*200-yOffset)
		end
	end
	y2=tonumber(mapWindow.Y:GetText())
	if (y+1)~=y2 then
		mapWindow.Y:SetText(tostring(y+1))
		-- reload the grid images since we have a new start coordinate
		mapWindow.ReloadGrid()
	end
end

mapWindow.hGridScroll=Turbine.UI.Lotro.ScrollBar();
mapWindow.hGridScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
mapWindow.hGridScroll:SetParent(mapWindow);
mapWindow.hGridScroll:SetBackColor(Turbine.UI.Color(0,0,0));
mapWindow.hGridScroll:SetWidth(mapWindow.mapGrid:GetWidth());
mapWindow.hGridScroll:SetHeight(10);
mapWindow.hGridScroll:SetPosition(mapWindow.mapGrid:GetLeft(),mapWindow.mapGrid:GetTop()+mapWindow.mapGrid:GetHeight());
mapWindow.hGridScroll:SetMinimum(0)
mapWindow.hGridScroll:SetMaximum((MaxCol[1]-mapWindow.GridCols+2)*200-1)

mapWindow.hGridScroll:SetValue(0)
mapWindow.hGridScroll:SetZOrder(mapWindow.mapGrid:GetZOrder()+1);
mapWindow.hGridScroll:SetVisible(true);
mapWindow.hGridScroll.ValueChanged=function(sender,args)
	local xValue=mapWindow.hGridScroll:GetValue();
	local x=math.floor(xValue/200)
	local xOffset=xValue-x*200

	-- now move all of the grid elements to the xOffset
	for row,rowCells in ipairs(mapWindow.GridCells) do
		for col,Cell in ipairs(rowCells) do
			Cell:SetLeft((col-1)*200-xOffset)
		end
	end
	x2=tonumber(mapWindow.X:GetText())
	if (x+1)~=x2 then
		mapWindow.X:SetText(tostring(x+1))
		-- reload the grid images since we have a new start coordinate
		mapWindow.ReloadGrid()
	end
end

hudVisible=true; -- terrible assumption but we have no choice
mapVisible=false;
usageVisible=false;
mapWindow.KeyDown=function(sender, args)
--Turbine.Shell.WriteLine("KeyDown Action="..args.Action..", .Alt="..tostring(args.Alt)..", .Control="..tostring(args.Control)..", .Shift="..tostring(args.Shift))
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		mapWindow:SetVisible(false)
		usageWindow:SetVisible(false)
	elseif ( args.Action == 268435635 ) then -- toggle HUD
		hudVisible=not hudVisible;
		if hudVisible then
			mapWindow:SetVisible(mapVisible);
			usageWindow:SetVisible(usageVisible);
		else
			usageVisible=usageWindow:IsVisible();
			usageWindow:SetVisible(false);
			mapVisible=mapWindow:IsVisible();
			mapWindow:SetVisible(false);
		end
	end
end

plugin.Unload=function()
	Turbine.Shell.RemoveCommand(mapWindow.shellCmd)
	SaveData();
	-- remove shell commands
	Turbine.Shell.WriteLine("TerrainMap "..Plugins["TerrainMap"]:GetVersion().." by Garan unloaded");
end

mapWindow.shellCmd=Turbine.ShellCommand();
Turbine.Shell.AddCommand("TerrainMap",mapWindow.shellCmd);

mapWindow.shellCmd.Execute = function(sender, cmd, args)
	if (string.lower(cmd) == "terrainmap") then
		local pos1=string.find(args," ",0,true);
		local command;
		args=string.lower(args)
		if pos1~=nil and pos1>0 then
			command=string.sub(args,1,pos1-1);
		else
			command=args;
		end
		if (command=="show") then
			mapWindow:SetVisible(true);
		elseif (args=="debug on") then
			if debugWindow==nil then
				debugWindow=DebugWindow()
			end
			debugWindow:SetVisible(true);
		elseif (args=="debug off") then
			if debugWindow~=nil then
				debugWindow:SetVisible(false);
			end
		elseif (args=="usage") then
			usageWindow.UpdateUsage()
			usageWindow:SetVisible(true)
		else
			Turbine.Shell.WriteLine("usage:");
			Turbine.Shell.WriteLine("  /MapMaker show");
			Turbine.Shell.WriteLine("       Displays the MapMaker window.");
			Turbine.Shell.WriteLine("  /MapMaker debug on|off");
			Turbine.Shell.WriteLine("       Shows or Hides the Debug window.");
		end
	end
end
mapWindow.shellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /MapMaker show\n       Displays the MapMaker window.");
end
mapWindow.shellCmd.GetShortHelp = function(sender, cmd)
	return("MapMaker - usage: /MapMaker show");
end

mapWindow:ReloadGrid()
mapWindow:SetVisible(true);
mapWindow:SetZOrder(mapWindow:GetZOrder()+1);

usageWindow=Turbine.UI.Window()
usageWindow:SetSize(displayWidth,displayHeight)
usageWindow:SetVisible(false)
usageWindow:SetBackColor(Turbine.UI.Color.Black)
usageWindow:SetZOrder(2)
usageWindow.CloseButton=Turbine.UI.Control()
usageWindow.CloseButton:SetParent(usageWindow)
usageWindow.CloseButton:SetSize(16,16)
usageWindow.CloseButton:SetPosition(displayWidth-16,0)
usageWindow.CloseButton:SetBackground(0x41000196)
usageWindow.CloseButton.MouseClick=function()
	usageWindow:SetVisible(false)
end
usageWindow.CloseButton.MouseEnter=function()
	usageWindow.CloseButton:SetBackground(0x41000198)
end
usageWindow.CloseButton.MouseLeave=function()
	usageWindow.CloseButton:SetBackground(0x41000196)
end
usageWindow.Display=Turbine.UI.ListBox()
usageWindow.Display:SetParent(usageWindow)
usageWindow.Display:SetSize(displayWidth-16,displayHeight-26)
usageWindow.Display:SetBackColor(Turbine.UI.Color.Green)
usageWindow.Display:SetPosition(0,16)

usageWindow.UpdateUsage=function()
	local region=mapWindow.Region:GetSelectedChoice()
	usageWindow.Display:ClearItems()
	for tmpIndex=1,MaxRow[region] do
		local tmpRow=Turbine.UI.Label()
		tmpRow:SetBackColor(Turbine.UI.Color.Blue)
		tmpRow:SetParent(usageWindow.Display)
		tmpRow:SetSize(MaxCol[region]*7+15,7)
		tmpRow.Row=tmpIndex
		tmpRow.MouseClick=function(sender,args)
			local row=sender.Row-1
			local col=math.floor(args.X/7)
			mapWindow.hGridScroll:SetValue(col*200)
			mapWindow.hGridScroll.ValueChanged()
			mapWindow.vGridScroll:SetValue(row*200)
			mapWindow.vGridScroll.ValueChanged()
			usageWindow:SetVisible(false)
		end
		usageWindow.Display:AddItem(tmpRow)
	end
-- create the strings based on existance of an image at each row/col
	for row=1,MaxRow[region] do
		local lbl=usageWindow.Display:GetItem(row)
		local tmpStr=""
		for col=1,MaxCol[region] do
			local gridRegion=Grid[region]
			local char="\194\183"
			if gridRegion~=nil then
				local gridRow=gridRegion[row]
				if gridRow~=nil then
					local gridCol=gridRow[col]
					if gridCol~=nil and gridCol[1]~=nil then
						char="\194\164"
					end
				end
			end
			tmpStr=tmpStr..char
		end
		lbl:SetText(tmpStr)
	end
end

usageWindow.vScroll=Turbine.UI.Lotro.ScrollBar();
usageWindow.vScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
usageWindow.vScroll:SetParent(usageWindow);
usageWindow.vScroll:SetBackColor(Turbine.UI.Color(0,0,0));
usageWindow.vScroll:SetWidth(10);
usageWindow.vScroll:SetHeight(usageWindow.Display:GetHeight());
usageWindow.vScroll:SetPosition(usageWindow.Display:GetLeft()+usageWindow.Display:GetWidth(),usageWindow.Display:GetTop());
usageWindow.Display:SetVerticalScrollBar(usageWindow.vScroll)

usageWindow.hScroll=Turbine.UI.Lotro.ScrollBar();
usageWindow.hScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
usageWindow.hScroll:SetParent(usageWindow);
usageWindow.hScroll:SetBackColor(Turbine.UI.Color(0,0,0));
usageWindow.hScroll:SetHeight(10);
usageWindow.hScroll:SetWidth(usageWindow.Display:GetWidth());
usageWindow.hScroll:SetPosition(usageWindow.Display:GetLeft(),displayHeight-10);
usageWindow.Display:SetHorizontalScrollBar(usageWindow.hScroll)
